#include "simulators-common.h"

using namespace IDSIA;

class NetworkScheduler
{
  public:

  NetworkScheduler(int _port_base) : port_base(_port_base)  { msg_buf = new char[MAX_MSG_SIZE]; };

  void OpenSocketWithRobotSimScheduler(); 
  void GetSimulationInformation();
  void SendNetworkSimInfo(char *sim_name);
  void GetNodePositionsUpdate();
  void UpdateNodePositions();
  void SendNetworkAck(int step);

  int  GetRobotNum() { return sim_info.robot_num; }
  Real GetSimulationTimeStep() { return sim_info.simulation_step; }
  char *GetRobotSimulatorName() { return sim_info.simulator_name; }
  Real GetCurrentTimeSlice() { return current_time; }
  inline Socket GetSocket() { return socket; }

  protected:

  Socket socket;
  int port_base;
  int msg_size;

  SimulationInformationPacket sim_info;
  NetworkSimInfoPacket msg_net_info;
  NodePositionsPacket msg_positions;
  Real current_time;
  char *msg_buf;


  int updated_positions;
  Position *node_positions;
};
