/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
/*
 * Copyright (c) 2010 UCM
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation;
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Author:  Delfín Rupérez Cañas <delfinrc@fdi.ucm.es>
 *          
 */

#ifndef ANTORSTAT_H_
#define ANTORSTAT_H_

#include "ns3/uinteger.h"

namespace ns3 {

namespace antordlr {

class AntORStat {



public:

    AntORStat();
    ~AntORStat() {}


    uint32_t getByteHelloReceived() const {
        return m_ByteHelloReceived;
    }

    uint32_t getByteHelloSent() const {
        return m_ByteHelloSent;
    }

    uint32_t getBytePacketSent() const {
        return m_BytePacketSent;
    }

    uint32_t getBytesLFNReceived() const {
        return m_BytesLFNReceived;
    }

    uint32_t getBytesLFNSent() const {
        return m_BytesLFNSent;
    }

    uint32_t getBytesPBAReceived() const {
        return m_BytesPBAReceived;
    }

    uint32_t getBytesPBASent() const {
        return m_BytesPBASent;
    }

    uint32_t getBytesPFAReceived() const {
        return m_BytesPFAReceived;
    }

    uint32_t getBytesPFASent() const {
        return m_BytesPFASent;
    }

    uint32_t getBytesRBAReceived() const {
        return m_BytesRBAReceived;
    }

    uint32_t getBytesRBASent() const {
        return m_BytesRBASent;
    }

    uint32_t getBytesRFAReceived() const {
        return m_BytesRFAReceived;
    }

    uint32_t getBytesRFASent() const {
        return m_BytesRFASent;
    }

    uint32_t getBytesRRBAReceived() const {
        return m_BytesRRBAReceived;
    }

    uint32_t getBytesRRBASent() const {
        return m_BytesRRBASent;
    }

    uint32_t getBytesRRFAReceived() const {
        return m_BytesRRFAReceived;
    }

    uint32_t getBytesRRFASent() const {
        return m_BytesRRFASent;
    }

    uint32_t getHelloReceived() const {
        return m_HelloReceived;
    }

    uint32_t getHelloSent() const {
        return m_HelloSent;
    }

    uint32_t getLFNReceived() const {
        return m_LFNReceived;
    }

    uint32_t getLFNSent() const {
        return m_LFNSent;
    }

    uint32_t getPBAReceived() const {
        return m_PBAReceived;
    }

    uint32_t getPBASent() const {
        return m_PBASent;
    }

    uint32_t getPFAReceived() const {
        return m_PFAReceived;
    }

    uint32_t getPFASent() const {
        return m_PFASent;
    }

    uint32_t getPacketSent() const {
        return m_packetSent;
    }

    uint32_t getRBAReceived() const {
        return m_RBAReceived;
    }

    uint32_t getRBASent() const {
        return m_RBASent;
    }

    uint32_t getRFAReceived() const {
        return m_RFAReceived;
    }

    uint32_t getRFASent() const {
        return m_RFASent;
    }

    uint32_t getRRBAReceived() const {
        return m_RRBAReceived;
    }

    uint32_t getRRBASent() const {
        return m_RRBASent;
    }

    uint32_t getRRFAReceived() const {
        return m_RRFAReceived;
    }

    uint32_t getRRFASent() const {
        return m_RRFASent;
    }

    void setByteHelloReceived(uint32_t m_ByteHelloReceived) {
        this->m_ByteHelloReceived = m_ByteHelloReceived;
    }

    void setByteHelloSent(uint32_t m_ByteHelloSent) {
        this->m_ByteHelloSent = m_ByteHelloSent;
    }

    void setBytePacketSent(uint32_t m_BytePacketSent) {
        this->m_BytePacketSent = m_BytePacketSent;
    }

    void setBytesLFNReceived(uint32_t m_BytesLFNReceived) {
        this->m_BytesLFNReceived = m_BytesLFNReceived;
    }

    void setBytesLFNSent(uint32_t m_BytesLFNSent) {
        this->m_BytesLFNSent = m_BytesLFNSent;
    }

    void setBytesPBAReceived(uint32_t m_BytesPBAReceived) {
        this->m_BytesPBAReceived = m_BytesPBAReceived;
    }

    void setBytesPBASent(uint32_t m_BytesPBASent) {
        this->m_BytesPBASent = m_BytesPBASent;
    }

    void setBytesPFAReceived(uint32_t m_BytesPFAReceived) {
        this->m_BytesPFAReceived = m_BytesPFAReceived;
    }

    void setBytesPFASent(uint32_t m_BytesPFASent) {
        this->m_BytesPFASent = m_BytesPFASent;
    }

    void setBytesRBAReceived(uint32_t m_BytesRBAReceived) {
        this->m_BytesRBAReceived = m_BytesRBAReceived;
    }

    void setBytesRBASent(uint32_t m_BytesRBASent) {
        this->m_BytesRBASent = m_BytesRBASent;
    }

    void setBytesRFAReceived(uint32_t m_BytesRFAReceived) {
        this->m_BytesRFAReceived = m_BytesRFAReceived;
    }

    void setBytesRFASent(uint32_t m_BytesRFASent) {
        this->m_BytesRFASent = m_BytesRFASent;
    }

    void setBytesRRBAReceived(uint32_t m_BytesRRBAReceived) {
        this->m_BytesRRBAReceived = m_BytesRRBAReceived;
    }

    void setBytesRRBASent(uint32_t m_BytesRRBASent) {
        this->m_BytesRRBASent = m_BytesRRBASent;
    }

    void setBytesRRFAReceived(uint32_t m_BytesRRFAReceived) {
        this->m_BytesRRFAReceived = m_BytesRRFAReceived;
    }

    void setBytesRRFASent(uint32_t m_BytesRRFASent) {
        this->m_BytesRRFASent = m_BytesRRFASent;
    }

    void setHelloReceived(uint32_t m_HelloReceived) {
        this->m_HelloReceived = m_HelloReceived;
    }

    void setHelloSent(uint32_t m_HelloSent) {
        this->m_HelloSent = m_HelloSent;
    }

    void setLFNReceived(uint32_t m_LFNReceived) {
        this->m_LFNReceived = m_LFNReceived;
    }

    void setLFNSent(uint32_t m_LFNSent) {
        this->m_LFNSent = m_LFNSent;
    }

    void setPBAReceived(uint32_t m_PBAReceived) {
        this->m_PBAReceived = m_PBAReceived;
    }

    void setPBASent(uint32_t m_PBASent) {
        this->m_PBASent = m_PBASent;
    }

    void setPFAReceived(uint32_t m_PFAReceived) {
        this->m_PFAReceived = m_PFAReceived;
    }

    void setPFASent(uint32_t m_PFASent) {
        this->m_PFASent = m_PFASent;
    }

    void setPacketSent(uint32_t m_packetSent) {
        this->m_packetSent = m_packetSent;
    }

    void setRBAReceived(uint32_t m_RBAReceived) {
        this->m_RBAReceived = m_RBAReceived;
    }

    void setRBASent(uint32_t m_RBASent) {
        this->m_RBASent = m_RBASent;
    }

    void setRFAReceived(uint32_t m_RFAReceived) {
        this->m_RFAReceived = m_RFAReceived;
    }

    void setRFASent(uint32_t m_RFASent) {
        this->m_RFASent = m_RFASent;
    }

    void setRRBAReceived(uint32_t m_RRBAReceived) {
        this->m_RRBAReceived = m_RRBAReceived;
    }

    void setRRBASent(uint32_t m_RRBASent) {
        this->m_RRBASent = m_RRBASent;
    }

    void setRRFAReceived(uint32_t m_RRFAReceived) {
        this->m_RRFAReceived = m_RRFAReceived;
    }

    void setRRFASent(uint32_t m_RRFASent) {
        this->m_RRFASent = m_RRFASent;
    }
    void setULNReceived(uint32_t m_r) {
         this->m_ULNReceived = m_r;
     }

     void setULNSent(uint32_t m_s) {
         this->m_ULNSent = m_s;
     }


private:


    uint32_t m_HelloSent;
    uint32_t m_ByteHelloSent;

    uint32_t m_HelloReceived;
    uint32_t m_ByteHelloReceived;

    uint32_t m_RFASent;
    uint32_t m_BytesRFASent;

    uint32_t m_RFAReceived;
    uint32_t m_BytesRFAReceived;


    uint32_t m_RBASent;
    uint32_t m_BytesRBASent;

    uint32_t m_RBAReceived;
    uint32_t m_BytesRBAReceived;


    uint32_t m_PFASent;
    uint32_t m_BytesPFASent;

    uint32_t m_PFAReceived;
    uint32_t m_BytesPFAReceived;


    uint32_t m_PBASent;
    uint32_t m_BytesPBASent;

    uint32_t m_PBAReceived;
    uint32_t m_BytesPBAReceived;


    uint32_t m_LFNSent;
    uint32_t m_BytesLFNSent;

    uint32_t m_LFNReceived;
    uint32_t m_BytesLFNReceived;


    uint32_t m_RRFASent;
    uint32_t m_BytesRRFASent;

    uint32_t m_RRFAReceived;
    uint32_t m_BytesRRFAReceived;


    uint32_t m_RRBASent;
    uint32_t m_BytesRRBASent;

    uint32_t m_RRBAReceived;
    uint32_t m_BytesRRBAReceived;

    uint32_t m_ULNReceived;
    uint32_t m_BytesULNReceived;


    uint32_t m_ULNSent;
    uint32_t m_BytesULNSent;

    uint32_t m_packetSent;
    uint32_t m_BytePacketSent;

};


}
} // namespace ns3

#endif /* ANTORSTAT_H_ */
