#include "MacDelaysTag.h"

#include "ns3/simulator.h"

using namespace ns3;

TypeId MacDelaysTag::GetTypeId(void){
	static TypeId tid = TypeId("ns3::MacDelaysTag")
	.SetParent<Tag>()
	.AddConstructor<MacDelaysTag>();
	return tid;
}

TypeId MacDelaysTag::GetInstanceTypeId(void) const{
	return GetTypeId();
}

MacDelaysTag::MacDelaysTag(){
}

uint32_t MacDelaysTag::GetSerializedSize(void) const{
	uint32_t s = 0;
	//adding the size of snr and pwr
	s+= sizeof(double)*2;
	s+= sizeof(uint32_t);
	return s;
}

MacDelaysTag::~MacDelaysTag(){

}


void MacDelaysTag::Serialize(TagBuffer i) const{
	i.WriteDouble(requestAccessTime);
	i.WriteDouble(handshakeTime);
	i.WriteU32(currentNPacketsInQueue);
}

void MacDelaysTag::Deserialize(TagBuffer i){
	requestAccessTime=i.ReadDouble();
	handshakeTime=i.ReadDouble();
	currentNPacketsInQueue=i.ReadU32();
}
void MacDelaysTag::Print (std::ostream &os) const{

}

// Accessors
void MacDelaysTag::SetRequestAccessTime(double r) {
	requestAccessTime = r;
}
void MacDelaysTag::SetHandshakeTime(double h){
	handshakeTime = h;
}

void MacDelaysTag::SetCurrentNPacketsInQueue(uint32_t n) {
	currentNPacketsInQueue = n;
}

double MacDelaysTag::GetRequestAccessTime(void){
	return requestAccessTime;
}
double MacDelaysTag::GetHandshakeTime(void){
	return handshakeTime;
}

uint32_t MacDelaysTag::GetCurrentNPacketsInQueue(void) {
	return currentNPacketsInQueue;
}

