#ifndef _MACDELAYSTAG_H_
#define _MACDELAYSTAG_H_

#include "ns3/tag.h"
#include "ns3/packet.h"
#include "ns3/uinteger.h"

using namespace ns3;

class MacDelaysTag : public Tag{
public:
	static TypeId GetTypeId (void); //required by ns3
	virtual TypeId GetInstanceTypeId(void) const;
	virtual uint32_t GetSerializedSize(void) const;
	virtual void Serialize(TagBuffer i) const;
	virtual void Deserialize(TagBuffer i);
	MacDelaysTag();
	virtual ~MacDelaysTag ();
	virtual void Print (std::ostream &os) const;
	//accessor
	void SetRequestAccessTime(double r);
	void SetHandshakeTime(double h);
	void SetCurrentNPacketsInQueue(uint32_t n);
	double GetRequestAccessTime(void);
	double GetHandshakeTime(void);
	uint32_t GetCurrentNPacketsInQueue(void);

private:
	double requestAccessTime;
	double handshakeTime;
	uint32_t currentNPacketsInQueue;
};



#endif /* _MACDELAYSTAG_H_ */
