#ifndef _PHYSIGNALTAG_H_
#define _PHYSIGNALTAG_H_

#include "ns3/tag.h"
#include "ns3/packet.h"
#include "ns3/uinteger.h"

using namespace ns3;

class PhySignalTag : public Tag{
public:
	static TypeId GetTypeId (void); //required by ns3
	virtual TypeId GetInstanceTypeId(void) const;
	virtual uint32_t GetSerializedSize(void) const;
	virtual void Serialize(TagBuffer i) const;
	virtual void Deserialize(TagBuffer i);
	PhySignalTag();
	virtual ~PhySignalTag ();
	virtual void Print (std::ostream &os) const;
	//accessor
	void SetSnr(double s);
	void SetPwr(double p);
	double GetSnr(void);
	double GetPwr(void);

private:
	double snr;
	double pwr;
};



#endif /* _PHYSIGNALTAG_H_ */
